

#include "SparseMatrix.hpp"
#include  "LSolver.hpp"
#include <vector>
#include <iostream>
#include <fstream>




namespace MFound {

class MyTypes {
public:
  typedef double Scalar;
  typedef std::vector<double> Array;
  typedef std::vector<double> Vector;  
};
};

using namespace MFound;
using namespace std;



/* This is a simple wrapper to test your solver class. You need to change this file to fit the specifrication of the homework.

It reads the solver matrix from file argv[1] 
reads the right hand side from argvp2[
and opututs the solution in file argv[3]

the argv[3] contains a string which specifies which solvers to be used.
0 = TAUCS
1 = Eigen
(this is not implemented)
 */
int main(int argc, char* argv[]){

  if(argc!=5){
    cout<<"Invalid number of argumentes!!!"<<endl;
    return -1;
  }

  ifstream fi1(argv[1]);
  if(!fi1){
    cout<<"Unable to open the file "<<argv[1]<<endl;
    return -1;
  }
 
  // load the solver
  GenericLSolver<MyTypes> gs;
  fi1>>gs;
  
  ifstream fi2(argv[2]);
  if(!fi2){
    cout<<"Unable to open the file "<<argv[2]<<endl;
    return -1;
  }

  // load the b vector
  MyTypes::Vector b;
  int n;
  fi2>>n;
  b.resize(n);
  for(int i=0;i<n;++i)
    fi2>>b[i];

  // solve
  MyTypes::Vector x(gs.getN());
  gs.solve(x, b);
  
  // output solution
  ofstream fo(argv[3]);
  if(!fo){
    cout<<"Unable to open the file "<<argv[3]<<endl;
    return -1;
  }
  
  fo<<x.size();
  for(int i=0;i<n;++i)
    fo<<x[i];
  
  return 0;
}

